package k.ld31;

import k.lib.graphics.DisplayObject;

class Bar extends DisplayObject {
	var bottom:Int;
	var max:Int;
	var value:Float;

	var waitingForDeletion:Array<DisplayObject>;
	var waitingForAddition:Array<DisplayObject>;

	public function new(x:Int, y:Int, max:Int, value:Float) {
		super();
		this.x = x;
		this.y = y;
		this.max = max;
		this.value = 0;
		waitingForDeletion = [];
		waitingForAddition = [];
		updateValue(value);
		bottom = y;
		has_update = true;
	}

	public function updateValue(v:Float):Void {
		if (v < 0 || v > 1) return;

		if (v > value) {
			for (i in Std.int(max * value)...Std.int(max * v)) {
				var d:DisplayObject = new DisplayObject("bar");
				d.y = max - i;
				waitingForAddition.push(d);
			}
		} else {
			for (i in Std.int(max * v)...(Std.int(max * value)+1)) {
				waitingForDeletion.push(children[i]);
			}
		}

		value = v;
	}

	override private inline function onUpdate():Void {
		if (waitingForDeletion.length > 0) {
			var n_delete:Int = Std.int(waitingForDeletion.length/3) + 1;
			for (i in 0...n_delete) {
				removeChild(waitingForDeletion.pop());
			}
		}

		if (waitingForAddition.length > 0) {
			var n_delete:Int = Std.int(waitingForAddition.length/3) + 1;
			for (i in 0...n_delete) {
				addChild(waitingForAddition.shift());
			}
		}
	}
}

