package k.ld31;


import k.lib.graphics.DisplayObject;
import k.lib.graphics.Shake;
import k.lib.utils.Color;

class Monster extends DisplayObject {
	private static inline var SPEED:Float = 0.65;
	public var life:Int;

	public function new(x:Int, y:Int) {
		super("monster");

		cx = x; cy = y;
		customx = this.x = Tama.toAbsoluteX(cx);
		customy = this.y = Tama.toAbsoluteY(cy);
		has_update = true;
		life = 2;
		radius = 8;
		__align = DisplayObject.ALIGN_CENTER;

		shakingColorFilter = Shake.FILTER_SOFT;
	}

	override private inline function onUpdate():Void {
		if (!Tama.locked) {
			var b:DisplayObject = overlapsGroup(Tama.instance.shurikens);
			if (b != null) {
				Tama.hitMonster(this);
				Tama.killShuriken(b);
			}
			if (overlaps(Tama.instance.tama)) Tama.hitTama(this);
			if (overlaps(Tama.instance.player)) Tama.hitPlayer(this);

			var b:DisplayObject = overlapsArray(Tama.instance.poo);
			if (b != null) {
				Tama.hitMonster(this);
			}

			cx = Tama.toCellX(customx);
			cy = Tama.toCellY(customy);

			var target:DisplayObject = Tama.instance.tama;
			var path = Tama.instance.pathfinder.getPath({x: cx, y: cy}, {x: Tama.toCellX(target.x), y: Tama.toCellY(target.y)});
			path = Tama.instance.pathfinder.smooth(path);
			if (path.length > 1 && path[0].x == cx && path[0].y == cy) path.shift();
			
			var dest = path[0];
			if (dest != null) {
				var xDistance:Float = Tama.toAbsoluteX(dest.x) - customx;
				var yDistance:Float = Tama.toAbsoluteY(dest.y) - customy;

				if (Math.sqrt(yDistance*yDistance + xDistance*xDistance) < SPEED) {
					customx = Tama.toAbsoluteX(dest.x);
					customy = Tama.toAbsoluteY(dest.y);
				} else {
					var radian:Float = Math.atan2(yDistance, xDistance);
					customx += Math.cos(radian) * SPEED;
					customy += Math.sin(radian) * SPEED;
				}
				x = Std.int(customx);
				y = Std.int(customy);
			}
		}
	}
}